Package: causalWins
Title: Compute the Causal Win Ratio Using Nearest Neighbor Matching
Version: 0.1.0
Authors@R: 
  c(person(given = "Francisco",
           family = "Andrade",
           role = "aut",
           ),
    person(given = "Mathieu",
           family = "Even",
           role = c("aut", "cre"),
           email = "mathieu.even@inria.fr",
           ),
    person(given = "Julie",
           family = "Josse",
           role = "aut"))
Description: Based on “Rethinking the Win Ratio: A Causal Framework for Hierarchical Outcome Analysis” (M. Even and J. Josse, 2025), this package provides implementations of three approaches - nearest neighbor matching, distributional regression forests, and efficient influence functions - to estimate the causal win ratio, win proportion, and net benefit.
Encoding: UTF-8
License: AGPL (>= 3)
RoxygenNote: 7.3.3
Imports: drf, FactoMineR, grf, MatchIt
Suggests: knitr, rmarkdown, WINS, MASS
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2026-04-15 13:43:40 UTC; fdelimaa
Author: Francisco Andrade [aut],
  Mathieu Even [aut, cre],
  Julie Josse [aut]
Maintainer: Mathieu Even <mathieu.even@inria.fr>
Repository: CRAN
Date/Publication: 2026-04-21 18:22:13 UTC
Built: R 4.5.2; ; 2026-04-21 18:55:42 UTC; unix

Package: causalWins
Title: Compute the Causal Win Ratio Using Nearest Neighbor Matching
Version: 0.1.0
Authors@R: 
  c(person(given = "Francisco",
           family = "Andrade",
           role = "aut",
           ),
    person(given = "Mathieu",
           family = "Even",
           role = c("aut", "cre"),
           email = "mathieu.even@inria.fr",
           ),
    person(given = "Julie",
           family = "Josse",
           role = "aut"))
Description: Based on “Rethinking the Win Ratio: A Causal Framework for Hierarchical Outcome Analysis” (M. Even and J. Josse, 2025), this package provides implementations of three approaches - nearest neighbor matching, distributional regression forests, and efficient influence functions - to estimate the causal win ratio, win proportion, and net benefit.
Encoding: UTF-8
License: AGPL (>= 3)
RoxygenNote: 7.3.3
Imports: drf, FactoMineR, grf, MatchIt
Suggests: knitr, rmarkdown, WINS, MASS
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2026-04-15 13:43:40 UTC; fdelimaa
Author: Francisco Andrade [aut],
  Mathieu Even [aut, cre],
  Julie Josse [aut]
Maintainer: Mathieu Even <mathieu.even@inria.fr>
Repository: CRAN
Date/Publication: 2026-04-21 18:22:13 UTC
Built: R 4.6.0; ; 2026-04-25 14:07:31 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# causalWins

<!-- badges: start -->

<!-- badges: end -->

A package for estimating the causal win ratio, win proportion, and net
benefit using three distinct approaches as proposed in [Even et
al. (2025)](https://arxiv.org/abs/2501.16933): nearest neighbor
matching, distributed regression forests, and efficient influence
functions.

## Installation

You can install the development version of causalWins from
[GitHub](https://github.com/) with:

``` r
# install.packages("pak")
pak::pak("FranciscoAndrade90/causalWins")
```

## Example

This is a basic usage example:

``` r
library(causalWins)
# ---------------------------------------------------------
    # Generate data with mixed covariates
# ---------------------------------------------------------
set.seed(123)
n <- 100
base <- data.frame(
  X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
  X2 = rnorm(n, mean = 10, sd = 3), # numeric covariate 2
  X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
  Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
  arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
)
# ---------------------------------------------------------
    # Compute win ratio with nearest neighbor pairing
# ---------------------------------------------------------
res_nn <- nn_win_ratio(
  base = base,
  treatment_name = "arm",
  outcome_names = c("Y1", "Y2")
)
#> Covariates are both categorical and numerical.
#> No custom distance was provided.
#> Performing FAMD and setting distance to 'euclidean'.
#> Specify a distance function to override this choice.
# ---------------------------------------------------------
    # Compute win ratio with Distributional Random Forests
# ---------------------------------------------------------
res_drf <- drf_win_ratio(
  base = base,
  treatment_name = "arm",
  outcome_names = c("Y1", "Y2")
)
# ---------------------------------------------------------
    # Compute win ratio with Efficient Influence Functions
# ---------------------------------------------------------
res_eif <- eif_win_ratio(
  base = base,
  treatment_name = "arm",
  outcome_names = c("Y1", "Y2")
)
#> Covariates are both categorical and numerical.
#> No custom distance was provided.
#> Performing FAMD and setting distance to 'euclidean'.
#> Specify a distance function to override this choice.
#> No 'propensity_scores' was provided. 'Probability forest' will be used instead to compute those scores.
#> Specify 'propensity_scores' to override this choice.
```

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(causalWins)

## ----eval=FALSE---------------------------------------------------------------
# install.packages("causalWins")

## ----message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE----
# # ---------------------------------------------------------
#     # Generate data with mixed covariates
# # ---------------------------------------------------------
# set.seed(123)
# n <- 100
# base <- data.frame(
#   X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
#   X2 = rnorm(n, mean = 10, sd = 3), # numeric covariate 2
#   X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#   Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
#   Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
#   arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
# )
# # ---------------------------------------------------------
#     # Compute win ratio with nearest neighbor pairing
# # ---------------------------------------------------------
# res_nn <- nn_win_ratio(
#   base = base,
#   treatment_name = "arm",
#   outcome_names = c("Y1", "Y2")
# )
# # ---------------------------------------------------------
#     # Compute win ratio with Distributional Random Forests
# # ---------------------------------------------------------
# res_drf <- drf_win_ratio(
#   base = base,
#   treatment_name = "arm",
#   outcome_names = c("Y1", "Y2")
# )
# # ---------------------------------------------------------
#     # Compute win ratio with Efficient Influence Functions
# # ---------------------------------------------------------
# res_eif <- eif_win_ratio(
#   base = base,
#   treatment_name = "arm",
#   outcome_names = c("Y1", "Y2")
# )

## ----message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE----
# library(WINS)
# 
# # In this example, there are two subpopulations: A and B. The potential outcomes are
# 
# y_0a <- 4 # potential outcome of individuals of subpopulation A without treatment
# y_1b <- 3 # potential outcome of individuals of subpopulation B under treatment
# y_0b <- 2 # potential outcome of individuals of subpopulation B without treatment
# y_1a <- 1 # potential outcome of individuals of subpopulation A under treatment
# 
# alpha <- 1 / 3 # proportion of women
# 
# n_rounds <- 100
# n <- 300*1:5  # number of individuals 300, 600, 900, 1200, 1500
# 
# rct_prob <- .5 # probability of assignment to treatment/control group
# 
# results_nn <- data.frame(row_id = 1:n_rounds)
# results_comp <- data.frame(row_id = 1:n_rounds)
# 
# for (n_individuals in n) {
#   current_result_nn <- c()
#   current_result_comp <- c()
# 
#   for (round in 1:n_rounds) {
#     set.seed(123 + n_individuals + round)
# 
#     # ---------------------------------------------------
#     # Generate Data
#     # ---------------------------------------------------
# 
#     X <- rbinom(n_individuals, 1, alpha) # Sample element in A with prob `alpha`
#     treatment <- rbinom(n_individuals, 1, rct_prob) # Assign to treatment with prob `rct_prob`
#     Y <- X * treatment * y_1a + X * (1 - treatment) * y_0a +
#       (1 - X) * treatment * y_1b + (1 - X) * (1 - treatment) * y_0b # Outcomes
#     base <- data.frame(X = X, Y = Y, arm = treatment)
# 
#     # ---------------------------------------------------
#     # Compute Win Proportion for Nearest Neighbor Pairing
#     # ---------------------------------------------------
#     res_nn <- nn_win_ratio(
#       base = base,
#       treatment_name = "arm",
#       outcome_names = "Y"
#     )
#     res_nn <- res_nn$win_proportion$value
#     current_result_nn <- c(current_result_nn, res_nn)
# 
#     # ---------------------------------------------------
#     # Compute Win Proportion for Complete Pairing
#     # ---------------------------------------------------
#     data <- base
# 
#     colnames(data)[colnames(data) == "Y"] <- "Y_1" # Format for use with the WINS Package
#     data$id <- 1:n_individuals # Format for use with the WINS Package
#     res_comp <- WINS::win.stat(
#       data = data,
#       ep_type = "continuous",
#       arm.name = c(1, 0),
#       priority = c(1),
#       summary.print = FALSE
#     )
#     res_comp <- res_comp$Win_prop[[2]]
#     current_result_comp <- c(current_result_comp, res_comp)
#   }
#   results_nn[[as.character(n_individuals)]] <- current_result_nn
#   results_comp[[as.character(n_individuals)]] <- current_result_comp
# }

## ----myplot, fig.width=6, fig.height=4, dev='png', dpi=96, eval = FALSE-------
# results_nn$row_id <- NULL
# results_comp$row_id <- NULL
# 
# # # Interleave columns for side-by-side plotting
# combined <- unlist(Map(list, results_nn, results_comp), recursive = FALSE)
# 
# # Set names for x-axis
# names(combined) <- rep(names(results_nn), each = 2)
# 
# # Plot
# boxplot(combined,
#   col = rep(c("skyblue", "orange"), ncol(results_nn)),
#   las = 2,
#   main = "Comparison of the win proportions computed \nwith Nearest Neighbors and Complete Pairings",
#   ylab = "Win proportion",
#   xlab = "Number of patients (n)"
# )
# 
# legend("bottomleft",
#   legend = c("NN", "Complete"),
#   fill = c("skyblue", "orange")
# )
# 
# abline(h = 0.5, lty = 2, col = "red")

## ----echo=FALSE, out.width="70%"----------------------------------------------
knitr::include_graphics("figures/Example2.png")

## ----message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE----
# library(MASS)
# library(WINS)
# 
# n_rounds <- 100
# n <- 300* 1:5 # number of individuals 300, 600, 900, 1200, 1500
# 
# mu <- c(0, 0) # Covariates mean
# sigma <- matrix(c(1, 0.6, 0.6, 1), 2, 2) # Covariates covariance
# 
# tau_cont <- 2 # ATE of continuous outcome
# tau_bin <- 0.8 # ATE on logit scale of binary outcome
# 
# rct_prob <- .5 # probability of assignment to treatment/control group
# 
# results_nn <- data.frame(row_id = 1:n_rounds)
# results_comp <- data.frame(row_id = 1:n_rounds)
# 
# for (n_individuals in n) {
#   current_result_nn <- c()
#   current_result_comp <- c()
# 
#   for (round in 1:n_rounds) {
#     set.seed(123 + n_individuals + round)
# 
#     # ---------------------------------------------------
#     # Generate Covariates and Treatment
#     # ---------------------------------------------------
# 
#     covariates <- as.data.frame(mvrnorm(n_individuals, mu = mu, Sigma = sigma)) # covariates
#     colnames(covariates) <- c("X1", "X2")
#     treatment <- rbinom(n_individuals, 1, rct_prob) # Assign to treatment with prob `rct_prob`
# 
#     # ---------------------------------------------------
#     # Generate Binary Outcomes
#     # ---------------------------------------------------
#     # Potential Outcomes
#     lin_pred0 <- -1 + 0.3 * covariates$X1 - 0.5 * covariates$X2
#     lin_pred1 <- lin_pred0 + tau_bin
# 
#     # Sample binary potential outcomes
#     prob0 <- 1 / (1 + exp(-lin_pred0))
#     prob1 <- 1 / (1 + exp(-lin_pred1))
#     Y0_bin <- rbinom(n_individuals, size = 1, prob = prob0)
#     Y1_bin <- rbinom(n_individuals, size = 1, prob = prob1)
# 
#     # Observed binary outcome
#     Y_1 <- Y0_bin * (1 - treatment) + Y1_bin * treatment
# 
#     # ---------------------------------------------------
#     # Generate Continuous Outcomes
#     # ---------------------------------------------------
#     # Potential Outcomes
#     Y0_cont <- 1 + 0.5 * covariates$X1 - 0.7 * covariates$X2 + rnorm(n_individuals, 0, 1)
#     Y1_cont <- Y0_cont + tau_cont
# 
#     # Observed continuous outcome
#     Y_2 <- Y0_cont * (1 - treatment) + Y1_cont * treatment
# 
#     # ---------------------------------------------------
#     # Compute Win Proportion for Nearest Neighbor Pairing
#     # ---------------------------------------------------
#     base <- data.frame(covariates, arm = treatment, Y_1, Y_2)
# 
#     res_nn <- nn_win_ratio(
#       base = base,
#       treatment_name = "arm",
#       outcome_names = c("Y_1", "Y_2")
#     )
#     res_nn <- res_nn$win_proportion$value
#     current_result_nn <- c(current_result_nn, res_nn)
#     # ---------------------------------------------------
#     # Compute Win Proportion for Complete Pairing
#     # ---------------------------------------------------
#     data <- base
# 
#     data$id <- 1:n_individuals # Format for use with the WINS Package
#     res_comp <- WINS::win.stat(
#       data = data,
#       ep_type = c("binary", "continuous"),
#       arm.name = c(1, 0),
#       priority = c(1, 2),
#       summary.print = FALSE
#     )
#     res_comp <- res_comp$Win_prop[[2]]
#     current_result_comp <- c(current_result_comp, res_comp)
#   }
#   results_nn[[as.character(n_individuals)]] <- current_result_nn
#   results_comp[[as.character(n_individuals)]] <- current_result_comp
# }

## ----myplot2, fig.width=6, fig.height=4, dev='png', dpi=96, eval = FALSE------
# results_nn$row_id <- NULL
# results_comp$row_id <- NULL
# 
# # # Interleave columns for side-by-side plotting
# combined <- unlist(Map(list, results_nn, results_comp), recursive = FALSE)
# 
# # Set names for x-axis
# names(combined) <- rep(names(results_nn), each = 2)
# 
# # Plot
# boxplot(combined,
#   col = rep(c("skyblue", "orange"), ncol(results_nn)),
#   las = 2,
#   main = "Comparison of the win proportions computed \nwith Nearest Neighbors and Complete Pairings",
#   ylab = "Win proportion",
#   xlab = "Number of patients (n)"
# )
# 
# legend("bottomleft",
#   legend = c("NN", "Complete"),
#   fill = c("skyblue", "orange")
# )
# 
# abline(h = 0.5, lty = 2, col = "red")

## ----echo=FALSE, out.width="70%"----------------------------------------------
knitr::include_graphics("figures/Example3.png")

## ----message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE----
# library(doParallel)
# library(foreach)
# 
# n_rounds <- 100
# n <- 10000
# mu <- c(0, 0)
# sigma <- matrix(c(1, 0.6, 0.6, 1), 2, 2)
# tau_cont <- 2
# tau_bin <- 0.8
# 
# # Set up cluster
# n_cores <- parallel::detectCores() - 1  # leave 1 core free
# cl <- makeCluster(n_cores)
# registerDoParallel(cl)
# 
# results_eif <- foreach(
#   round = 1:n_rounds,
#   .combine = c,
#   .packages = c("MASS", "causalWins")
# ) %dopar% {
#   set.seed(123 + n + round)
# 
#   # -----------------------------------------------------------
#   # Generate Covariates and Treatment (observational)
#   # -----------------------------------------------------------
# 
#   covariates <- mvrnorm(n, mu = mu, Sigma = sigma) # covariates
#   colnames(covariates) <- c("X1", "X2")
#   covariates <- as.data.frame(covariates)
# 
#   p_treatment <- 1 / (1 + exp(-(0.5 * covariates$X1 - 0.3 * covariates$X2))) # non-rct
#   treatment <- rbinom(n, 1, p_treatment)
# 
#   # -----------------------------------------------------------
#   # Generate Binary Outcomes
#   # -----------------------------------------------------------
#   # Potential Outcomes
#   lin_pred0 <- -1 + 0.3 * covariates$X1 - 0.5 * covariates$X2
#   lin_pred1 <- lin_pred0 + tau_bin
# 
#   # Sample binary potential outcomes
#   prob0 <- 1 / (1 + exp(-lin_pred0))
#   prob1 <- 1 / (1 + exp(-lin_pred1))
#   Y0_bin <- rbinom(n, size = 1, prob = prob0)
#   Y1_bin <- rbinom(n, size = 1, prob = prob1)
# 
#   # Observed binary outcome
#   Y_1 <- Y0_bin * (1 - treatment) + Y1_bin * treatment
# 
#   # -----------------------------------------------------------
#   # Generate Continuous Outcomes
#   # -----------------------------------------------------------
#   # Potential Outcomes
#   Y0_cont <- 1 + 0.5 * covariates$X1 - 0.7 * covariates$X2 + rnorm(n, 0, 1)
#   Y1_cont <- Y0_cont + tau_cont
# 
#   # Observed continuous outcome
#   Y_2 <- Y0_cont * (1 - treatment) + Y1_cont * treatment
# 
#   # -----------------------------------------------------------
#   # Compute Win Proportion for drf and eif
#   # -----------------------------------------------------------
#   base <- data.frame(covariates, arm = treatment, Y_1, Y_2)
# 
#   res_eif <- eif_win_ratio(
#     base = base,
#     treatment_name = "arm",
#     outcome_names = c("Y_1", "Y_2"),
#     propensity_model = "glm"
#   )
# 
#   res_eif <- res_eif$win_proportion$value
# 
#   res_eif
# }
# stopCluster(cl)

## ----message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE----
# library(MASS)
# mu <- c(0, 0) # Covariates mean
# sigma <- matrix(c(1, 0.6, 0.6, 1), 2, 2)
# tau_cont <- 2 # ATE of continuous outcome
# tau_bin <- 0.8 # ATE on logit scale of binary outcome
# 
# # Default win function
# win_function <- function(y, z) {
#   if (all(y == z)) {
#     return(0) # Tie
#   }
#   result <- (y > z)[which.max(y != z)] * 1
#   return(result)
# }
# 
# mean_given <- function(x) {
#   n_samples <- 10000
#   # Binary potential outcomes
#   lin_pred0 <- -1 + 0.3 * x[1] - 0.5 * x[2]
#   lin_pred1 <- lin_pred0 + tau_bin
#   prob0 <- 1 / (1 + exp(-lin_pred0))
#   prob1 <- 1 / (1 + exp(-lin_pred1))
#   Y0_bin <- rbinom(n_samples, size = 1, prob = prob0)
#   Y1_bin <- rbinom(n_samples, size = 1, prob = prob1)
# 
#   # Continuous Potential Outcomes
#   Y0_cont <- 1 + 0.5 * x[1] - 0.7 * x[2] + rnorm(n_samples, 0, 1)
#   Y1_cont <- 1 + 0.5 * x[1] - 0.7 * x[2] + rnorm(n_samples, 0, 1) + tau_cont
# 
#   wins_given_x <- mapply(function(yb, yc, zb, zc) {
#     win_function(c(yb, yc), c(zb, zc))
#   }, Y1_bin, Y1_cont, Y0_bin, Y0_cont)
# 
#   return(mean(wins_given_x))
# }
# 
# set.seed(123)
# 
# covariates <- as.data.frame(mvrnorm(10000, mu = mu, Sigma = sigma))
# 
# tau_star <- mean(apply(covariates, 1, function(row) mean_given(row)))
# 

## ----myplot3, fig.width=6, fig.height=4, dev='png', dpi=96, eval = FALSE------
# boxplot(results_eif,
#   main = "Win proportion with EIF",
#   xlab = "Number of patients 10000",
#   ylab = "Win proportion"
# )
# abline(h = tau_star, lty = 2, col = "red")

## ----echo=FALSE, out.width="70%"----------------------------------------------
knitr::include_graphics("figures/EIF_resPlot.png")

compute_metrics <- function(win_vector, lose_vector) {
  res <- list()

  win_proportion <- mean(win_vector)
  lose_proportion <- mean(lose_vector)

  res$win_proportion$value <- win_proportion

  res$lose_proportion$value <- lose_proportion

  res$win_ratio$value <- win_proportion / lose_proportion

  res$net_benefit$value <- win_proportion - lose_proportion

  # Compute Standard Deviations and Confidence Intervals --------------------

  std_win_proportion <- stats::sd(win_vector)
  std_lose_proportion <- stats::sd(lose_vector)

  res$win_proportion$std <- std_win_proportion
  res$lose_proportion$std <- std_lose_proportion


  win_ratio_CI_res <- win_ratio_CI(win_vector,lose_vector)
  res$win_ratio$lower_CI <- win_ratio_CI_res$lower
  res$win_ratio$upper_CI <- win_ratio_CI_res$upper

  net_benefit_CI_res <- net_benefit_CI(win_vector,lose_vector)
  res$net_benefit$lower_CI <- net_benefit_CI_res$lower
  res$net_benefit$upper_CI <- net_benefit_CI_res$upper

  return(res)
}

win_ratio_CI <- function(win_vector, lose_vector) {
  n <- length(win_vector)

  win_mean <- mean(win_vector)
  lose_mean <- mean(lose_vector)

  win_ratio <- win_mean / lose_mean

  win_var <- stats::var(win_vector)
  lose_var <- stats::var(lose_vector)


  win_lose_cov <- stats::cov(win_vector, lose_vector)

  # Variance of  log(win_ratio)
  var_log_win_ratio <- win_var / (n * win_mean^2) + lose_var / (n * lose_mean^2) - 2 * win_lose_cov / (n * win_mean * lose_mean)

  se_log_win_ratio <- sqrt(var_log_win_ratio)

  # CI of log(win_ratio)

  z <- 1.96 # 95% CI
  log_lower <- log(win_ratio) - z * se_log_win_ratio
  log_upper <- log(win_ratio) + z * se_log_win_ratio

  # Exponentiate to get CI of win_ratio

  res <- list()

  res$lower <- exp(log_lower)
  res$upper <- exp(log_upper)

  return(res)
}

net_benefit_CI <- function(win_vector, lose_vector){

  differences <- win_vector - lose_vector

  net_benefit <- mean(differences)
  net_benefit_std <- stats::sd(differences)

  n <- length(differences)

  std <- net_benefit_std / sqrt(n)

  z <- 1.96 # 95% CI

  res <- list()

  res$lower <- net_benefit - z * std
  res$upper <- net_benefit + z * std

  return(res)
}

#' Win/Loss Ratios with Distributional Random Forests
#'
#' `drf_win_ratio()` Computes the win/loss proportion, win ratio, and net benefit
#' by estimating nuisance parameters with machine learning methods.
#' This estimation is performed via distributional regression, implemented using distributional random forests.
#' @param base A data frame with n rows (individuals) and p columns.
#' It must include a treatment column and one or more outcome columns.
#' All remaining columns are considered covariates for matching.
#' The data frame should not contain missing values. All covariates must be either numeric or factors.
#' @param treatment_name A character vector of length one for the treatment column name, must be in `names(base)`.
#' The treatment column should contain only zeros and ones, with ones indicating the treatment group.
#' @param outcome_names A character vector specifying the names of outcome columns.
#' All names must exist in `names(base)`. Each outcome column should be numeric or binary and
#' binary outcomes must be encoded as 0 and 1.
#' @param win_function By default, this function compares outcomes lexicographically according to the column order in the data frame,
#' treating higher values as better. Once a distinct outcome is found, the function yields 1 (a win) if that outcome is larger
#'  for the treated individual and 0 otherwise; in case of a tie, it yields 0.
#' To change the priority of outcomes, simply reorder the columns of the data frame.
#' Alternatively, `win_function` can be a custom function that takes two arguments, each corresponding to a row of the data frame:
#' `win_function(base[i, ], base[j, ])`
#' where the first argument represents a treated individual and the second a control individual.
#' The function must return a value between 0 and 1, with 1 indicating a win for the treated individual.
#' @param n_trees_drf Number of trees grown in the forest.
#' It passed as the argument `num.trees` to \code{\link[drf]{drf}}. The default value is 1000.
#' @param n_of_folds Number of folds used in cross-fitting. The default value is 3.
#' @param seed Numeric value used in `set.seed()` to guarantee reproducible results when sampling the folds. The default value is `NULL`.
#'
#' @returns A list of four elements, each of which is a list structured as follows:
#'
#' The first element, `win_proportion`, is a list with two components: `value` and `std`,
#' where `std` represents the standard deviation.
#'
#' The second element, `lose_proportion`, is a list with two components: `value` and `std`,
#' where `std` represents the standard deviation.
#'
#' The third element, `win_ratio`, is a list containing three components: `value`, `lower_CI`,
#' and `upper_CI`, with `lower_CI` and `upper_CI` representing the confidence interval bounds.
#'
#' The fourth element, `net_benefit`, is a list containing three components: `value`, `lower_CI`,
#' and `upper_CI`, with `lower_CI` and `upper_CI` representing the confidence interval bounds.
#'
#' The fifth and sixth elements, win_vector and lose_vector, are numeric vectors containing the nuisance function values evaluated for each individual.
#' @export
#'
#' @examples
#' ## Mixed Covariates ##
#'
#' set.seed(123)
#' n <- 100
#' base <- data.frame(
#'   X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
#'   X2 = rnorm(n, mean = 10, sd = 3), # numeric covariate 2
#'   X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#'   Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
#'   Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
#'   arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
#' )
#' treatment_name <- "arm"
#' outcome_names <- c("Y1", "Y2")
#' res <- drf_win_ratio(
#'   base = base,
#'   treatment_name = treatment_name,
#'   outcome_names = outcome_names
#' )
#' ## Categorical Covariates ##
#'
#' set.seed(123)
#' n <- 100
#' base <- data.frame(
#'   X1 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#'   X2 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#'   X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#'   Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
#'   Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
#'   arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
#' )
#' treatment_name <- "arm"
#' outcome_names <- c("Y1", "Y2")
#' res <- drf_win_ratio(
#'   base = base,
#'   treatment_name = treatment_name,
#'   outcome_names = outcome_names
#' )
drf_win_ratio <- function(base,
                          treatment_name,
                          outcome_names,
                          win_function = "lexicographic",
                          n_trees_drf = 1000,
                          n_of_folds = 3,
                          seed = NULL) {
  # Check Input & Extract Relevant Variables --------------------------------
  validate_input(
    base = base,
    treatment_name = treatment_name,
    outcome_names = outcome_names,
    win_function = win_function,
    n_trees_drf = n_trees_drf,
    n_of_folds = n_of_folds,
    seed = seed
  )

  covariate_names <- setdiff(colnames(base), c(outcome_names, treatment_name))

  if (is.character(win_function) && length(win_function) == 1 && win_function == "lexicographic") {
    win_function <- build_default_win_function(outcome_names)
  }

  lose_function <- function(treated_row, control_row) {
    win_function(control_row, treated_row)
  }

  n_of_individuals <- nrow(base)
  win_vector <- numeric(n_of_individuals)
  lose_vector <- numeric(n_of_individuals)

  # Cross-fitting Loop ------------------------------------------------------

  # Create Folds
  set.seed(seed = seed)
  folds <- sample(rep(1:n_of_folds, length.out = n_of_individuals))

  for (fold in 1:n_of_folds) {
    test_idx <- which(folds == fold)
    train_idx <- setdiff(1:n_of_individuals, test_idx)

    X_train <- stats::model.frame(~., data = base[train_idx, covariate_names, drop = FALSE], na.action = stats::na.pass)
    X_train <- stats::model.matrix(~ . - 1, X_train)
    Y_train <- base[train_idx, outcome_names, drop = FALSE]
    T_train <- base[train_idx, treatment_name, drop = FALSE]

    X_control_train <- X_train[T_train == 0, , drop = FALSE]
    Y_control_train <- Y_train[T_train == 0, , drop = FALSE]

    X_treated_train <- X_train[T_train == 1, , drop = FALSE]
    Y_treated_train <- Y_train[T_train == 1, , drop = FALSE]

    X_test <- stats::model.frame(~., data = base[test_idx, covariate_names, drop = FALSE], na.action = stats::na.pass)
    X_test <- stats::model.matrix(~ . - 1, X_test)

    # Train the Distributional Random Forests
    drf_control <- drf::drf(Y = Y_control_train, X = X_control_train, num.trees = n_trees_drf)
    drf_treated <- drf::drf(Y = Y_treated_train, X = X_treated_train, num.trees = n_trees_drf)

    # Compute the DRF weights
    weights_control <- stats::predict(drf_control, X_test, type = "weights")$weights
    weights_treated <- stats::predict(drf_treated, X_test, type = "weights")$weights

    len_test <- length(test_idx)

    for (l in seq_len(len_test)) {
      individual_j <- test_idx[l]
      group_of_j <- base[individual_j, treatment_name, drop = FALSE]
      outcome_of_j <- base[individual_j, outcome_names, drop = FALSE]

      # Select appropriate training outcomes and weights
      if (group_of_j == 1) {
        Y <- Y_control_train
        w <- weights_control[l, ]
        win_args <- function(i) win_function(outcome_of_j, Y[i, , drop = FALSE])
        lose_args <- function(i) lose_function(outcome_of_j, Y[i, , drop = FALSE])
      } else {
        Y <- Y_treated_train
        w <- weights_treated[l, ]
        win_args <- function(i) win_function(Y[i, , drop = FALSE], outcome_of_j)
        lose_args <- function(i) lose_function(Y[i, , drop = FALSE], outcome_of_j)
      }

      # Compute win/lose vectors
      pjwin <- vapply(seq_len(nrow(Y)), win_args, FUN.VALUE = 0)
      pjlose <- vapply(seq_len(nrow(Y)), lose_args, FUN.VALUE = 0)

      win_vector[individual_j] <- sum(w * pjwin)
      lose_vector[individual_j] <- sum(w * pjlose)
    }
  }

  # Compute Win/Lose Metrics ------------------------------------------------

  res <- compute_metrics(win_vector, lose_vector)
  res$win_vector <- win_vector
  res$lose_vector <- lose_vector

  return(res)
}

transform <- function(X, transformation) {
  if (transformation == "MCA") {
    X_transformed <- FactoMineR::MCA(X, ncp = Inf, graph = FALSE)
  } else {
    X_transformed <- FactoMineR::FAMD(X, ncp = Inf, graph = FALSE)
  }

  ncp95 <- sum(X_transformed$eig[, 3] < 95)
  if (is.na(ncp95)) {
    stop("Error: No valid components found to meet the threshold.")
  }

  X_transformed <- (X_transformed$ind$coord[, 1:ncp95, drop = FALSE])

  return(X_transformed)
}

preprocess <- function(base, covariate_names, treatment_name, transformation) {
  X <- base[, covariate_names, drop = FALSE]

  X_transformed <- transform(X, transformation)

  # Drop columns corresponding to X
  preprocessed_data <- base[, !(names(base) %in% covariate_names)]

  # Add columns corresponding to Xfamd
  preprocessed_data <- cbind(X_transformed, preprocessed_data)

  # Write the matching formula accordingly
  if (transformation == "FAMD") {
    dims <- paste("Dim", 1:NCOL(X_transformed), sep = ".")
    matching_formula <- stats::as.formula(
      paste(treatment_name, "~", paste(dims, collapse = " + "))
    )
  } else {
    dims <- paste0("`", colnames(X_transformed), "`")
    matching_formula <- stats::as.formula(
      paste(treatment_name, "~", paste(dims, collapse = " + "))
    )
  }

  return(list(
    preprocessed_data = preprocessed_data,
    matching_formula = matching_formula
  ))
}

#' Win/Loss Ratios with Efficient Influence Functions
#'
#' `eif_win_ratio()` calculates the win/loss proportion, win ratio, and net benefit
#' by adding a correction term to `drf_win_ratio()` using Efficient Influence Functions.
#' @param base A data frame with n rows (individuals) and p columns.
#' It must include a treatment column and one or more outcome columns.
#' All remaining columns are considered covariates for matching.
#' The data frame should not contain missing values. All covariates must be either numeric or factors.
#' @param treatment_name A character vector of length one for the treatment column name, must be in `names(base)`.
#' The treatment column should contain only zeros and ones, with ones indicating the treatment group.
#' @param outcome_names A character vector specifying the names of outcome columns.
#' All names must exist in `names(base)`. Each outcome column should be numeric or binary and
#' binary outcomes must be encoded as 0 and 1.
#' @param win_function By default, this function compares outcomes lexicographically according to the column order in the data frame,
#' treating higher values as better. Once a distinct outcome is found, the function yields 1 (a win) if that outcome is larger
#'  for the treated individual and 0 otherwise; in case of a tie, it yields 0.
#' To change the priority of outcomes, simply reorder the columns of the data frame.
#' Alternatively, `win_function` can be a custom function that takes two arguments, each corresponding to a row of the data frame:
#' `win_function(base[i, ], base[j, ])`
#' where the first argument represents a treated individual and the second a control individual.
#' The function must return a value between 0 and 1, with 1 indicating a win for the treated individual.
#' @param distance A function that is used to compute the nearest neighbor matching on covariates.
#' The distance function will be passed as an argument to \code{\link[MatchIt]{matchit}} (see  \code{\link[MatchIt]{distance}}).
#'
#'  **Default Distance Settings**
#'
#' The default value for the distance parameter is `NULL`. If no distance is provided, the function assigns defaults based on the type of covariates:
#'
#' - **Mixed covariates:** Applies Factor Analysis of Mixed Data transformation (see \code{\link[FactoMineR]{FAMD}}) to the covariates and sets distance to `"euclidean"`.
#' - **Numeric covariates:** Sets distance to `"euclidean"`.
#' - **Categorical covariates:** Applies Multiple Correspondence Analysis (see \code{\link[FactoMineR]{MCA}}) transformation to the covariates and sets distance to `"euclidean"`.
#' @param n_trees_drf Number of trees grown in the distributional random forests.
#' It passed as the argument `num.trees` to \code{\link[drf]{drf}}. The default value is 1000.
#' @param n_of_folds Number of folds used in cross-fitting. The default value is 3.
#' @param seed Numeric value used in `set.seed()` to guarantee reproducible results when sampling the folds. The default value is `NULL`.
#' @param propensity_model Character string specifying the type of model to use.
#'   Must be either "glm" or "probability_forest".
#'   Defaults to "probability_forest". The model is only used if no vector
#'   of propensity scores (`propensity_scores`) is provided.
#' @param n_trees_propensity Number of trees grown when computing the propensity scores using `propensity_model`.
#' @param propensity_scores Numeric vector of propensity score probabilities
#' @param clip_propensity Numeric value used to clip propensity scores,
#'   ensuring they lie within the interval `[clip_propensity, 1 - clip_propensity]`. The default value is zero.
#'
#' @returns A list of six elements, each of which is a list structured as follows:
#'
#' The first element, `win_proportion`, is a list with two components: `value` and `std`,
#' where `std` represents the standard deviation.
#'
#' The second element, `lose_proportion`, is a list with two components: `value` and `std`,
#' where `std` represents the standard deviation.
#'
#' The third element, `win_ratio`, is a list containing three components: `value`, `lower_CI`,
#' and `upper_CI`, with `lower_CI` and `upper_CI` representing the confidence interval bounds.
#'
#' The fourth element, `net_benefit`, is a list containing three components: `value`, `lower_CI`,
#' and `upper_CI`, with `lower_CI` and `upper_CI` representing the confidence interval bounds.
#'
#' The fifth and sixth elements, `win_vector` and `lose_vector`, are numeric vectors containing the plug-in estimator
#' evaluated for each individual, along with the corresponding EIF correction term.
#' @export
#'
#' @examples
#' ## Input Propensity Scores ##
#'
#' set.seed(123)
#' n <- 100
#' base <- data.frame(
#'   X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
#'   X2 = rnorm(n, mean = 10, sd = 3), # numeric covariate 2
#'   X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#'   Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
#'   Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
#'   arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
#' )
#' treatment_name <- "arm"
#' outcome_names <- c("Y1", "Y2")
#'
#' ps_model <- stats::glm(arm ~ X1 + X3, # only consider X1 and X3 and no cross-fitting
#'   family = binomial(),
#'   data = base
#' )
#'
#' propensity_scores <- stats::predict(ps_model, type = "response")
#' res <- eif_win_ratio(
#'   base = base,
#'   treatment_name = treatment_name,
#'   outcome_names = outcome_names,
#'   propensity_scores = propensity_scores
#' )
eif_win_ratio <- function(base,
                          treatment_name,
                          outcome_names,
                          win_function = "lexicographic",
                          distance = NULL,
                          n_trees_drf = 1000,
                          n_of_folds = 3,
                          seed = NULL,
                          propensity_model = "probability_forest",
                          n_trees_propensity = 1000,
                          propensity_scores = NULL,
                          clip_propensity = 0.0) {
  # Check Input & Compute 'drf_win_ratio' and 'nn_win_ratio' ----------------

  validate_propensity_input(propensity_model, n_trees_propensity, propensity_scores, clip_propensity)

  # The remaining inputs are checked by the calls to 'nn_win_ratio' and 'drf_win_ratio'
  res_nn <- nn_win_ratio(
    base = base,
    treatment_name = treatment_name,
    outcome_names = outcome_names,
    win_function = win_function,
    distance = distance
  )

  res_drf <- drf_win_ratio(
    base = base,
    treatment_name = treatment_name,
    outcome_names = outcome_names,
    win_function = win_function,
    n_trees_drf = n_trees_drf,
    n_of_folds = n_of_folds,
    seed = seed
  )

  win_vector_nn <- res_nn$win_vector
  lose_vector_nn <- res_nn$lose_vector

  win_vector_drf <- res_drf$win_vector
  lose_vector_drf <- res_drf$lose_vector

  n_of_individuals <- nrow(base)

  # Compute Propensity Scores (if needed) -----------------------------------

  if (is.null(propensity_scores)) {
    propensity_model_str <- sub(
      "^[a-z]",
      toupper(substr(propensity_model, 1, 1)),
      sub("_", " ", propensity_model)
    )
    message(
      sprintf(
        "No 'propensity_scores' was provided. '%s' will be used instead to compute those scores.",
        propensity_model_str
      )
    )
    message("Specify 'propensity_scores' to override this choice.")

    propensity_scores <- compute_propensity_scores(
      base = base,
      treatment_name = treatment_name,
      outcome_names = outcome_names,
      n_of_folds = n_of_folds,
      seed = seed,
      propensity_model = propensity_model,
      n_trees_propensity = n_trees_propensity
    )
  }
  for (i in 1:n_of_individuals) {
    propensity_scores[i] <- min(propensity_scores[i], 1 - clip_propensity)
    propensity_scores[i] <- max(propensity_scores[i], clip_propensity)
  }

  ip_weights <- ifelse(
    base[[treatment_name]] == 1,
    1 / propensity_scores,
    1 / (1 - propensity_scores)
  )
  # Compute Win/Lose vectors ------------------------------------------------

  win_vector <- win_vector_nn + ip_weights * (win_vector_drf - win_vector_nn)
  lose_vector <- lose_vector_nn + ip_weights * (lose_vector_drf - lose_vector_nn)

  # Compute Win/Lose Metrics ------------------------------------------------

  res <- compute_metrics(win_vector, lose_vector)
  res$win_vector <- win_vector
  res$lose_vector <- lose_vector

  return(res)
}


compute_propensity_scores <- function(base,
                                      treatment_name,
                                      outcome_names,
                                      n_of_folds,
                                      seed,
                                      propensity_model,
                                      n_trees_propensity) {
  # Initialize
  n_of_individuals <- nrow(base)
  covariate_names <- setdiff(colnames(base), c(outcome_names, treatment_name))
  propensity_scores <- numeric(n_of_individuals)

  X <- stats::model.matrix(~ . - 1, data = base[, covariate_names, drop = FALSE])
  X <- as.matrix(X)

  Treatment <- base[[treatment_name]]

  # Create Folds
  set.seed(seed = seed)
  folds <- sample(rep(1:n_of_folds, length.out = n_of_individuals))

  for (fold in 1:n_of_folds) {
    test_idx <- which(folds == fold)
    train_idx <- setdiff(1:n_of_individuals, test_idx)

    X_train <- X[train_idx, , drop = FALSE]
    T_train <- Treatment[train_idx]

    if (propensity_model == "probability_forest") {
      T_train <- as.factor(T_train)
    }

    X_test <- X[test_idx, , drop = FALSE]

    if (propensity_model == "probability_forest") {
      regf <- grf::probability_forest(X_train, T_train, num.trees = n_trees_propensity)
      preds <- stats::predict(regf, X_test)$predictions[, 2]
    } else {
      lin_model <- stats::glm(T_train ~ ., data = data.frame(X_train, T_train), family = stats::binomial)
      preds <- stats::predict(lin_model, newdata = data.frame(X_test), type = "response")
    }
    propensity_scores[test_idx] <- preds
  }

  return(propensity_scores)
}

#' Win/Loss Ratios with Nearest Neighbor Matching
#'
#' `nn_win_ratio()` calculates the win/loss proportion, win ratio, and net benefit
#' by performing nearest-neighbor matching between individuals in the treatment group
#' and those in the control group based on a specified ground distance. After matching,
#' the outcomes of paired individuals are compared to determine winners and losers.
#' @param base A data frame with n rows (individuals) and p columns.
#' It must include a treatment column and one or more outcome columns.
#' All remaining columns are considered covariates for matching.
#' The data frame should not contain missing values. All covariates must be either numeric or factors.
#' @param treatment_name A character vector of length one for the treatment column name, must be in `names(base)`.
#' The treatment column should contain only zeros and ones, with ones indicating the treatment group.
#' @param outcome_names A character vector specifying the names of outcome columns.
#' All names must exist in `names(base)`. Each outcome column should be numeric or binary and
#' binary outcomes must be encoded as 0 and 1.
#' @param win_function By default, this function compares outcomes lexicographically according to the column order in the data frame,
#' treating higher values as better. Once a distinct outcome is found, the function yields 1 (a win) if that outcome is larger
#'  for the treated individual and 0 otherwise; in case of a tie, it yields 0.
#' To change the priority of outcomes, simply reorder the columns of the data frame.
#' Alternatively, `win_function` can be a custom function that takes two arguments, each corresponding to a row of the data frame:
#' `win_function(base[i, ], base[j, ])`
#' where the first argument represents a treated individual and the second a control individual.
#' The function must return a value between 0 and 1, with 1 indicating a win for the treated individual.
#' @param distance A function that is used to compute the nearest neighbor matching on covariates.
#' The distance function will be passed as an argument to \code{\link[MatchIt]{matchit}} (see  \code{\link[MatchIt]{distance}}).
#'
#' **Default Distance Settings**
#'
#' The default value for the distance parameter is `NULL`. If no distance is provided, the function assigns defaults based on the type of covariates:
#'
#' - **Numeric covariates:** Sets distance to `"euclidean"`.
#' - **Categorical covariates:** Applies Multiple Correspondence Analysis (see \code{\link[FactoMineR]{MCA}}) transformation to the covariates and sets distance to `"euclidean"`.
#' - **Mixed covariates:** Applies Factor Analysis of Mixed Data transformation (see \code{\link[FactoMineR]{FAMD}}) to the covariates and sets distance to `"euclidean"`.
#' @returns A list of six elements, each of which is a list structured as follows:
#'
#' The first element, `win_proportion`, is a list with two components: `value` and `std`,
#' where `std` represents the standard deviation.
#'
#' The second element, `lose_proportion`, is a list with two components: `value` and `std`,
#' where `std` represents the standard deviation.
#'
#' The third element, `win_ratio`, is a list containing three components: `value`, `lower_CI`,
#' and `upper_CI`, with `lower_CI` and `upper_CI` representing the confidence interval bounds.
#'
#' The fourth element, `net_benefit`, is a list containing three components: `value`, `lower_CI`,
#' and `upper_CI`, with `lower_CI` and `upper_CI` representing the confidence interval bounds.
#'
#' The fifth and sixth elements, `win_vector` and `lose_vector`, are numeric vectors representing the number of wins and losses
#' for each matched element, respectively. Their entries follow the same order as the rows in `base`.
#' @export
#'
#' @examples
#' ## Mixed Covariates ##
#'
#' set.seed(123)
#' n <- 100
#' base <- data.frame(
#'   X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
#'   X2 = rnorm(n, mean = 10, sd = 3), # numeric covariate 2
#'   X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#'   Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
#'   Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
#'   arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
#' )
#' treatment_name <- "arm"
#' outcome_names <- c("Y1", "Y2")
#' res <- nn_win_ratio(
#'   base = base,
#'   treatment_name = treatment_name,
#'   outcome_names = outcome_names
#' )
#'
#' ## Categorical Covariates ##
#'
#' set.seed(123)
#' n <- 100
#' base <- data.frame(
#'   X1 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#'   X2 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#'   X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
#'   Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
#'   Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
#'   arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
#' )
#' treatment_name <- "arm"
#' outcome_names <- c("Y1", "Y2")
#' res <- nn_win_ratio(
#'   base = base,
#'   treatment_name = treatment_name,
#'   outcome_names = outcome_names
#' )
#'
#' ## Input a Distance Matrix ##
#'
#' set.seed(123)
#' n <- 100
#' base <- data.frame(
#'   X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
#'   X2 = rnorm(n, mean = 5, sd = 2), # numeric covariate 2
#'   X3 = rnorm(n, mean = 5, sd = 2), # numeric covariate 3
#'   Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
#'   Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
#'   arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
#' )
#' treatment_name <- "arm"
#' outcome_names <- c("Y1", "Y2")
#'
#' covariate_names <- setdiff(colnames(base), c(outcome_names, treatment_name))
#' covariate_data <- base[, covariate_names, drop = FALSE]
#' distance_matrix <- as.matrix(dist(covariate_data, method = "euclidean"))
#'
#' res_dist <- nn_win_ratio(
#'   base = base,
#'   treatment_name = treatment_name,
#'   outcome_names = outcome_names,
#'   distance = distance_matrix
#' )
#'
#' res <- nn_win_ratio(
#'   base = base,
#'   treatment_name = treatment_name,
#'   outcome_names = outcome_names
#' )
#'
#' res <- unlist(res)
#' res_dist <- unlist(res_dist)
#'
#' print(all.equal(res, res_dist))
#'
#' ## Input a Win function ##
#'
#' set.seed(123)
#' n <- 100
#' base <- data.frame(
#'   X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
#'   X2 = rnorm(n, mean = 5, sd = 2), # numeric covariate 2
#'   X3 = rnorm(n, mean = 5, sd = 2), # numeric covariate 3
#'   Y1 = rbinom(n, size = 1, prob = 0.5), # binary outcome 1 (0/1) with 50% chance
#'   Y2 = rbinom(n, size = 10, prob = 0.7), # counts out of 10 trials with 70% success rate
#'   arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
#' )
#' treatment_name <- "arm"
#' outcome_names <- c("Y1", "Y2")
#'
#' # Contrary to the default win function, which yields 0 for ties,
#' # the following win function yields 0.5.
#'
#' win_function <- function(treated_row, control_row) {
#'   y <- as.matrix(treated_row[, outcome_names], drop = FALSE)
#'   z <- as.matrix(control_row[, outcome_names], drop = FALSE)
#'   if (all(y == z)) {
#'     return(0.5) # Tie, a zero in the default win function
#'   }
#'   result <- (y > z)[which.max(y != z)] * 1
#'   return(result)
#' }
#'
#' res <- nn_win_ratio(
#'   base = base,
#'   treatment_name = treatment_name,
#'   outcome_names = outcome_names,
#'   win_function = win_function
#' )
nn_win_ratio <- function(base,
                         treatment_name,
                         outcome_names,
                         win_function = "lexicographic",
                         distance = NULL) {
  # Check/Preprocess Input --------------------------------------------------
  if (any(is.na(base))) {
    stop("The data frame has missing values. Please remove or impute NAs before using this function.")
  }

  validate_input(base, treatment_name, outcome_names, win_function, distance = distance)

  if (any(is.na(base))) {
    stop("The data frame has missing values. Please remove or impute NAs before using this function.")
  }

  covariate_names <- setdiff(colnames(base), c(outcome_names, treatment_name))
  preprocessed_data <- base
  matching_formula <- stats::as.formula(paste(treatment_name, "~", paste(covariate_names, collapse = " + ")))

  if (is.null(distance) && categorical(base[covariate_names])) {
    message("Covariates are categorical.")
    message("No custom distance was provided.")
    message("Performing MCA and setting distance to 'euclidean'.")
    message("Specify a distance function to override this choice.")
    preprocess <- preprocess(base,
      covariate_names = covariate_names,
      treatment_name = treatment_name,
      transformation = "MCA"
    )
    preprocessed_data <- preprocess$preprocessed_data
    matching_formula <- preprocess$matching_formula
    distance <- "euclidean"
  }

  if (is.null(distance) && mixed(base[covariate_names])) {
    message("Covariates are both categorical and numerical.")
    message("No custom distance was provided.")
    message("Performing FAMD and setting distance to 'euclidean'.")
    message("Specify a distance function to override this choice.")
    preprocess <- preprocess(base,
      covariate_names = covariate_names,
      treatment_name = treatment_name,
      transformation = "FAMD"
    )
    preprocessed_data <- preprocess$preprocessed_data
    matching_formula <- preprocess$matching_formula
    distance <- "euclidean"
  }

  if (is.null(distance) && numerical(base[covariate_names])) {
    message("No custom distance was provided. Euclidean distance will be used for matching.")
    message("Specify a distance function to override this choice.")
    distance <- "euclidean"
  }

  if (is.character(win_function) && length(win_function) == 1 && win_function == "lexicographic") {
    win_function <- build_default_win_function(outcome_names)
  }

  lose_function <- function(treated_row, control_row) {
    win_function(control_row, treated_row)
  }

  # Create Pairs ------------------------------------------------------------

  treated_to_control <- nneighbor_match(preprocessed_data,
    matching_formula,
    distance,
    estimand = "ATT"
  )

  control_to_treated <- nneighbor_match(preprocessed_data,
    matching_formula,
    distance,
    estimand = "ATC"
  )

  # Compute Win/Lose vectors ------------------------------------------------

  n_of_individuals <- nrow(base)
  win_vector <- numeric(n_of_individuals)
  lose_vector <- numeric(n_of_individuals)

  treated_to_control_win <- apply_fun_to_pairs(
    base = base,
    pair_matrix = treated_to_control,
    funct = win_function
  )

  treated_to_control_lose <- apply_fun_to_pairs(
    base = base,
    pair_matrix = treated_to_control,
    funct = lose_function
  )

  control_to_treated_win <- apply_fun_to_pairs(
    base = base,
    pair_matrix = control_to_treated,
    funct = win_function
  )

  control_to_treated_lose <- apply_fun_to_pairs(
    base = base,
    pair_matrix = control_to_treated,
    funct = lose_function
  )

  win_vector[treated_to_control[, 1]] <- treated_to_control_win
  lose_vector[treated_to_control[, 1]] <- treated_to_control_lose
  win_vector[control_to_treated[, 2]] <- control_to_treated_win
  lose_vector[control_to_treated[, 2]] <- control_to_treated_lose

  # Compute Win/Lose Metrics ------------------------------------------------

  res <- compute_metrics(win_vector, lose_vector)
  res$win_vector <- win_vector
  res$lose_vector <- lose_vector

  return(res)
}

nneighbor_match <- function(preprocessed_data, matching_formula, distance, estimand = "ATT") {
  # Create pairs
  matchings <- MatchIt::matchit(
    formula = matching_formula,
    data = preprocessed_data,
    method = "nearest",
    distance = distance,
    ratio = 1,
    replace = TRUE,
    estimand = estimand
  )
  pairs <- matchings$match.matrix

  if (estimand == "ATT") {
    treated <- as.numeric(rownames(pairs))
    control <- as.numeric(pairs)
  } else {
    control <- as.numeric(rownames(pairs))
    treated <- as.numeric(pairs)
  }

  pair_matrix <- cbind(treated, control)

  # Drop lines that yielded (if any) missing values
  pair_matrix <- pair_matrix[stats::complete.cases(pair_matrix), , drop = FALSE]

  return(pair_matrix)
}

apply_fun_to_pairs <- function(base, pair_matrix, funct) {
  n_rows <- nrow(pair_matrix)

  res <- vapply(
    seq_len(n_rows),
    function(k) {
      funct(base[pair_matrix[k, 1], ], base[pair_matrix[k, 2], ])
    },
    FUN.VALUE = 0
  )

  return(res)
}

mixed <- function(base) {
  return(any(sapply(base, is.factor)) && any(sapply(base, is.numeric)))
}

numerical <- function(base) {
  return(all(sapply(base, is.numeric)))
}

categorical <- function(base) {
  return(all(sapply(base, is.factor)))
}


validate_input <- function(base,
                           treatment_name,
                           outcome_names,
                           win_function,
                           n_trees_drf = NULL,
                           n_of_folds = NULL,
                           seed = NULL,
                           distance = NULL) {
  # Check for Missing Data ----------------------------------------
  if (any(is.na(base[, outcome_names, drop = FALSE]))) {
    stop("The data frame contains missing outcomes. Please remove or impute NAs before using this function.")
  }


  # Check type --------------------------------------------------------------

  if (!is.data.frame(base)) stop("Argument 'base' must be a data.frame.")
  if (!is.character(treatment_name) || length(treatment_name) != 1) {
    stop("Argument 'treatment_name' must be a single string (character vector of length 1).")
  }
  if (!is.character(outcome_names)) stop("Argument 'outcome_names' must be a character.")

  covariate_names <- setdiff(colnames(base), c(outcome_names, treatment_name))

  if (length(covariate_names) == 0) {
    stop("No covariates found. This method requires covariates.")
  }

  if (is.character(win_function) && length(win_function) == 1 && win_function != "lexicographic") {
    stop("Argument 'win_function' is either 'lexicographic' or a function.")
  }
  if (is.character(win_function) && length(win_function) != 1) {
    stop("Argument 'win_function' is either 'lexicographic' or a function.")
  }

  if (!is.character(win_function)) {
    if (!is.function(win_function) || length(formals(win_function)) != 2) {
      stop("Argument 'win_function' is either 'lexicographic' or a function of exactly two arguments.")
    }
  }

  # Check Input Conformity --------------------------------------------------
  columns <- colnames(base)

  if (!all(treatment_name %in% columns)) stop("Argument 'treatment_name' must be the name of a 'data' column.")
  if (!all(outcome_names %in% columns)) stop("Argument 'outcome_names' must be a subset of the 'data' columns.")

  if (!all(vapply(base[outcome_names], function(x) is.numeric(x), FUN.VALUE = logical(1)))) {
    stop("Elements of 'base[outcome_names]' must all be numeric.")
  }

  if (!all(is.numeric(base[[treatment_name]])) || !all(base[[treatment_name]] %in% c(0, 1))) {
    stop("Elements of 'base[[treatment_name]]' must all be numeric and binary.")
  }

  if (!is.null(n_trees_drf)) {
    check_positive_integer(n_trees_drf)
  }

  if (!is.null(n_of_folds)) {
    check_positive_integer(n_of_folds)
  }

  if (!is.null(seed)) {
    check_positive_integer(seed)
  }

  return(invisible(TRUE))
}

check_positive_integer <- function(x) {
  arg_name <- deparse(substitute(x)) # Capture the argument name

  # Check if x is numeric
  if (!is.numeric(x)) {
    stop(sprintf("Argument '%s' must be numeric.", arg_name))
  }

  # Check if x is a whole number
  if (x != floor(x)) {
    stop(sprintf("Argument '%s' must be an integer (no decimals).", arg_name))
  }

  # Check if x is positive
  if (x <= 0) {
    stop(sprintf("Argument '%s' must be a positive integer.", arg_name))
  }

  return(invisible(TRUE))
}

validate_propensity_input <- function(propensity_model, n_trees_propensity, propensity_scores, clip_propensity) {
  # Check propensity_model
  if (!is.character(propensity_model) || length(propensity_model) != 1) {
    stop("Argument 'propensity_model' must be a single character string.")
  }
  if (!propensity_model %in% c("probability_forest", "glm")) {
    stop("Argument 'propensity_model' must be either 'probability_forest' or 'regression_forest'.")
  }

  # Check propensity_scores
  if (!is.null(propensity_scores)) {
    if (!is.numeric(propensity_scores)) {
      stop("Argument 'propensity_scores' must be a numeric vector.")
    }
    if (any(is.na(propensity_scores))) {
      stop("The vector 'propensity_scores' must not contain missing values.")
    }
    if (any(propensity_scores < 0 | propensity_scores > 1)) {
      stop("All entries in 'propensity_scores' must be between 0 and 1.")
    }
  }

  # Check clip_propensity
  if (!is.numeric(clip_propensity) || length(clip_propensity) != 1) {
    stop("Argument 'clip_propensity' must be a single numeric value.")
  }
  if (clip_propensity < 0 || clip_propensity > 1) {
    stop("Argument 'clip_propensity' must be between 0 and 1.")
  }

  if (!is.null(n_trees_propensity)) {
    check_positive_integer(n_trees_propensity)
  }

  return(invisible(TRUE))
}

build_default_win_function <- function(outcome_names) {
  function(treated_row, control_row) {
    y <- as.matrix(treated_row[, outcome_names], drop = FALSE)
    z <- as.matrix(control_row[, outcome_names], drop = FALSE)
    if (all(y == z)) {
      return(0) # Tie
    }
    result <- (y > z)[which.max(y != z)] * 1
    return(result)
  }
}

---
title: "A Causal
Framework for Hierarchical Outcome Analysis"
output: rmarkdown::html_vignette
bibliography: biblio.bib
vignette: >
  %\VignetteIndexEntry{A Causal Framework for Hierarchical Outcome Analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(causalWins)
```

## Description

Quantifying causal effects with complex, multivariate outcomes remains a challenge in treatment evaluation. For hierarchical outcomes, regulatory agencies such as the U.S. Food and Drug Administration recommend methods based on the Win Ratio (@pocock2012win) and Generalized Pairwise Comparisons (@buyse2010generalized). These approaches typically estimate (in this vignette using the WINS package by @WINS) a population-level quantity — the probability that a randomly selected treated patient fares better than a randomly selected control patient. In @even2025, the authors studied another quantity that can be very interesting in this individual context: the probability that a given individual would have a better outcome under treatment than under control. Unfortunately, this quantity is not identifiable, because for each individual we do not observe both the treated and control outcomes. @even2025 thus proposed a proxy for this quantity that is identifiable, and three ways to estimate it. This package implements that methodology and the three complementary estimators: (i) a nearest-neighbor matching estimator (nn_win_ratio), (ii) a distributional regression estimator (drf_win_ratio), and (iii) a semiparametric efficient estimator (eif_win_ratio).

## How to install

The latest release of the package can be installed through CRAN (soon):

```{r, eval=FALSE}
install.packages("causalWins")
```

## Example 1

The goal of this example is to illustrate, in a simple setting, how to use the functions `nn_win_ratio`, `drf_win_ratio`, and `eif_win_ratio`. The estimators produced by these functions target the causal (non-identifiable) quantity

$$
\tau_{\text{indiv}} := \mathbb{E}\Big[w\big(Y_i(1) \big| Y_i(0)\big)\Big],
$$

where $Y_i(0)$ and $Y_i(1)$ denote the potential outcomes for individual $i$ under control and treatment, respectively. The function $w(\cdot| \cdot)$ compares these outcomes to determine whether a patient benefits more from treatment or from control. This measure is not identifiable.  The authors of @buyse2010generalized introduce the following population quantity estimated via nearest-neighbor matching:
\[
\tau_{\text{pop}} := \mathbb{E}\Big[w\big(Y_i(1)\,\big|\, Y_j(0)\big)\Big],
\]
where $i$ and $j$ are two different and independent individuals. In @even2025 the authors studied a proxy of the individual quantity,

$$
\tau^\star := \mathbb{E}\Big[ w\big(Y^{(X_i)}(1), Y_i(0)\big) \Big], \quad \text{ where } \tau^\star(x) := \mathbb{E}\Big[ w\big(Y^{(x)}(1), Y_i(0)\big) \;\big|\; X_i = x \Big],
$$
and where for $x \in X$, $\{Y^{(x)}(0), Y^{(x)}(1)\}$ denotes an independent copy of
$\{Y_i(0), Y_i(1)\} \mid X_i = x$.


For more details on how to use them, please refer to the function documentation `?nn_win_ratio`, `?drf_win_ratio` and `eif_win_ratio`.

```{r, message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE}
# ---------------------------------------------------------
    # Generate data with mixed covariates
# ---------------------------------------------------------
set.seed(123)
n <- 100
base <- data.frame(
  X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
  X2 = rnorm(n, mean = 10, sd = 3), # numeric covariate 2
  X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
  Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
  arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
)
# ---------------------------------------------------------
    # Compute win ratio with nearest neighbor pairing
# ---------------------------------------------------------
res_nn <- nn_win_ratio(
  base = base,
  treatment_name = "arm",
  outcome_names = c("Y1", "Y2")
)
# ---------------------------------------------------------
    # Compute win ratio with Distributional Random Forests
# ---------------------------------------------------------
res_drf <- drf_win_ratio(
  base = base,
  treatment_name = "arm",
  outcome_names = c("Y1", "Y2")
)
# ---------------------------------------------------------
    # Compute win ratio with Efficient Influence Functions
# ---------------------------------------------------------
res_eif <- eif_win_ratio(
  base = base,
  treatment_name = "arm",
  outcome_names = c("Y1", "Y2")
)
```

## Example 2  

Drawing on Example 2 from @even2025, the following simulation illustrates the potential discrepancy between the historical Win Ratio and the individual-level estimator proposed in that work. The historical Win Ratio estimated here using the `WINS` package (@WINS), which is based on complete pairing, differs from the estimates obtained via the individual-level approach and the `causalWins` package, which employs nearest-neighbor (NN) matching.

```{r, message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE}
library(WINS)

# In this example, there are two subpopulations: A and B. The potential outcomes are

y_0a <- 4 # potential outcome of individuals of subpopulation A without treatment
y_1b <- 3 # potential outcome of individuals of subpopulation B under treatment
y_0b <- 2 # potential outcome of individuals of subpopulation B without treatment
y_1a <- 1 # potential outcome of individuals of subpopulation A under treatment

alpha <- 1 / 3 # proportion of women

n_rounds <- 100
n <- 300*1:5  # number of individuals 300, 600, 900, 1200, 1500

rct_prob <- .5 # probability of assignment to treatment/control group

results_nn <- data.frame(row_id = 1:n_rounds)
results_comp <- data.frame(row_id = 1:n_rounds)

for (n_individuals in n) {
  current_result_nn <- c()
  current_result_comp <- c()

  for (round in 1:n_rounds) {
    set.seed(123 + n_individuals + round)

    # ---------------------------------------------------
    # Generate Data
    # ---------------------------------------------------

    X <- rbinom(n_individuals, 1, alpha) # Sample element in A with prob `alpha`
    treatment <- rbinom(n_individuals, 1, rct_prob) # Assign to treatment with prob `rct_prob`
    Y <- X * treatment * y_1a + X * (1 - treatment) * y_0a +
      (1 - X) * treatment * y_1b + (1 - X) * (1 - treatment) * y_0b # Outcomes
    base <- data.frame(X = X, Y = Y, arm = treatment)

    # ---------------------------------------------------
    # Compute Win Proportion for Nearest Neighbor Pairing
    # ---------------------------------------------------
    res_nn <- nn_win_ratio(
      base = base,
      treatment_name = "arm",
      outcome_names = "Y"
    )
    res_nn <- res_nn$win_proportion$value
    current_result_nn <- c(current_result_nn, res_nn)

    # ---------------------------------------------------
    # Compute Win Proportion for Complete Pairing
    # ---------------------------------------------------
    data <- base

    colnames(data)[colnames(data) == "Y"] <- "Y_1" # Format for use with the WINS Package
    data$id <- 1:n_individuals # Format for use with the WINS Package
    res_comp <- WINS::win.stat(
      data = data,
      ep_type = "continuous",
      arm.name = c(1, 0),
      priority = c(1),
      summary.print = FALSE
    )
    res_comp <- res_comp$Win_prop[[2]]
    current_result_comp <- c(current_result_comp, res_comp)
  }
  results_nn[[as.character(n_individuals)]] <- current_result_nn
  results_comp[[as.character(n_individuals)]] <- current_result_comp
}
```

### Boxplots

We now present boxplots of the simulated win proportions calculated using the `causalWins` and `WINS` packages. The results indicate that, under substantial heterogeneity, the two methods are not equivalent and can result in different treatment recommendations.

```{r myplot, fig.width=6, fig.height=4, dev='png', dpi=96, eval = FALSE}
results_nn$row_id <- NULL
results_comp$row_id <- NULL

# # Interleave columns for side-by-side plotting
combined <- unlist(Map(list, results_nn, results_comp), recursive = FALSE)

# Set names for x-axis
names(combined) <- rep(names(results_nn), each = 2)

# Plot
boxplot(combined,
  col = rep(c("skyblue", "orange"), ncol(results_nn)),
  las = 2,
  main = "Comparison of the win proportions computed \nwith Nearest Neighbors and Complete Pairings",
  ylab = "Win proportion",
  xlab = "Number of patients (n)"
)

legend("bottomleft",
  legend = c("NN", "Complete"),
  fill = c("skyblue", "orange")
)

abline(h = 0.5, lty = 2, col = "red")
```

```{r, echo=FALSE, out.width="70%"}
knitr::include_graphics("figures/Example2.png")
```

## Example 3
In contrast with the previous example, the following simulation demonstrates that in an RCT with a more homogeneous population, the complete pairing and nearest neighbor approaches yield broadly similar results.

```{r, message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE}
library(MASS)
library(WINS)

n_rounds <- 100
n <- 300* 1:5 # number of individuals 300, 600, 900, 1200, 1500

mu <- c(0, 0) # Covariates mean
sigma <- matrix(c(1, 0.6, 0.6, 1), 2, 2) # Covariates covariance

tau_cont <- 2 # ATE of continuous outcome
tau_bin <- 0.8 # ATE on logit scale of binary outcome

rct_prob <- .5 # probability of assignment to treatment/control group

results_nn <- data.frame(row_id = 1:n_rounds)
results_comp <- data.frame(row_id = 1:n_rounds)

for (n_individuals in n) {
  current_result_nn <- c()
  current_result_comp <- c()

  for (round in 1:n_rounds) {
    set.seed(123 + n_individuals + round)

    # ---------------------------------------------------
    # Generate Covariates and Treatment
    # ---------------------------------------------------

    covariates <- as.data.frame(mvrnorm(n_individuals, mu = mu, Sigma = sigma)) # covariates
    colnames(covariates) <- c("X1", "X2")
    treatment <- rbinom(n_individuals, 1, rct_prob) # Assign to treatment with prob `rct_prob`

    # ---------------------------------------------------
    # Generate Binary Outcomes
    # ---------------------------------------------------
    # Potential Outcomes
    lin_pred0 <- -1 + 0.3 * covariates$X1 - 0.5 * covariates$X2
    lin_pred1 <- lin_pred0 + tau_bin

    # Sample binary potential outcomes
    prob0 <- 1 / (1 + exp(-lin_pred0))
    prob1 <- 1 / (1 + exp(-lin_pred1))
    Y0_bin <- rbinom(n_individuals, size = 1, prob = prob0)
    Y1_bin <- rbinom(n_individuals, size = 1, prob = prob1)

    # Observed binary outcome
    Y_1 <- Y0_bin * (1 - treatment) + Y1_bin * treatment

    # ---------------------------------------------------
    # Generate Continuous Outcomes
    # ---------------------------------------------------
    # Potential Outcomes
    Y0_cont <- 1 + 0.5 * covariates$X1 - 0.7 * covariates$X2 + rnorm(n_individuals, 0, 1)
    Y1_cont <- Y0_cont + tau_cont

    # Observed continuous outcome
    Y_2 <- Y0_cont * (1 - treatment) + Y1_cont * treatment

    # ---------------------------------------------------
    # Compute Win Proportion for Nearest Neighbor Pairing
    # ---------------------------------------------------
    base <- data.frame(covariates, arm = treatment, Y_1, Y_2)

    res_nn <- nn_win_ratio(
      base = base,
      treatment_name = "arm",
      outcome_names = c("Y_1", "Y_2")
    )
    res_nn <- res_nn$win_proportion$value
    current_result_nn <- c(current_result_nn, res_nn)
    # ---------------------------------------------------
    # Compute Win Proportion for Complete Pairing
    # ---------------------------------------------------
    data <- base

    data$id <- 1:n_individuals # Format for use with the WINS Package
    res_comp <- WINS::win.stat(
      data = data,
      ep_type = c("binary", "continuous"),
      arm.name = c(1, 0),
      priority = c(1, 2),
      summary.print = FALSE
    )
    res_comp <- res_comp$Win_prop[[2]]
    current_result_comp <- c(current_result_comp, res_comp)
  }
  results_nn[[as.character(n_individuals)]] <- current_result_nn
  results_comp[[as.character(n_individuals)]] <- current_result_comp
}
```

### Boxplots

Unlike the previous plot, we now observe that both approaches yield similar treatment recommendations.

```{r myplot2, fig.width=6, fig.height=4, dev='png', dpi=96, eval = FALSE}
results_nn$row_id <- NULL
results_comp$row_id <- NULL

# # Interleave columns for side-by-side plotting
combined <- unlist(Map(list, results_nn, results_comp), recursive = FALSE)

# Set names for x-axis
names(combined) <- rep(names(results_nn), each = 2)

# Plot
boxplot(combined,
  col = rep(c("skyblue", "orange"), ncol(results_nn)),
  las = 2,
  main = "Comparison of the win proportions computed \nwith Nearest Neighbors and Complete Pairings",
  ylab = "Win proportion",
  xlab = "Number of patients (n)"
)

legend("bottomleft",
  legend = c("NN", "Complete"),
  fill = c("skyblue", "orange")
)

abline(h = 0.5, lty = 2, col = "red")
```

```{r, echo=FALSE, out.width="70%"}
knitr::include_graphics("figures/Example3.png")
```

## Example 4
This simulation illustrates the application of the Efficient Influence Function (EIF) method. The data-generating process is similar to the previous example: covariates are produced in the same way. However, the treatment assignment is no longer randomized. Instead, it depends on the covariates, meaning the setting corresponds to an observational study. 

```{r, message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE}
library(doParallel)
library(foreach)

n_rounds <- 100
n <- 10000
mu <- c(0, 0)
sigma <- matrix(c(1, 0.6, 0.6, 1), 2, 2)
tau_cont <- 2
tau_bin <- 0.8

# Set up cluster
n_cores <- parallel::detectCores() - 1  # leave 1 core free
cl <- makeCluster(n_cores)
registerDoParallel(cl)

results_eif <- foreach(
  round = 1:n_rounds,
  .combine = c,
  .packages = c("MASS", "causalWins")
) %dopar% {
  set.seed(123 + n + round)

  # -----------------------------------------------------------
  # Generate Covariates and Treatment (observational)
  # -----------------------------------------------------------

  covariates <- mvrnorm(n, mu = mu, Sigma = sigma) # covariates
  colnames(covariates) <- c("X1", "X2")
  covariates <- as.data.frame(covariates)

  p_treatment <- 1 / (1 + exp(-(0.5 * covariates$X1 - 0.3 * covariates$X2))) # non-rct
  treatment <- rbinom(n, 1, p_treatment)

  # -----------------------------------------------------------
  # Generate Binary Outcomes
  # -----------------------------------------------------------
  # Potential Outcomes
  lin_pred0 <- -1 + 0.3 * covariates$X1 - 0.5 * covariates$X2
  lin_pred1 <- lin_pred0 + tau_bin

  # Sample binary potential outcomes
  prob0 <- 1 / (1 + exp(-lin_pred0))
  prob1 <- 1 / (1 + exp(-lin_pred1))
  Y0_bin <- rbinom(n, size = 1, prob = prob0)
  Y1_bin <- rbinom(n, size = 1, prob = prob1)

  # Observed binary outcome
  Y_1 <- Y0_bin * (1 - treatment) + Y1_bin * treatment

  # -----------------------------------------------------------
  # Generate Continuous Outcomes
  # -----------------------------------------------------------
  # Potential Outcomes
  Y0_cont <- 1 + 0.5 * covariates$X1 - 0.7 * covariates$X2 + rnorm(n, 0, 1)
  Y1_cont <- Y0_cont + tau_cont

  # Observed continuous outcome
  Y_2 <- Y0_cont * (1 - treatment) + Y1_cont * treatment

  # -----------------------------------------------------------
  # Compute Win Proportion for drf and eif
  # -----------------------------------------------------------
  base <- data.frame(covariates, arm = treatment, Y_1, Y_2)

  res_eif <- eif_win_ratio(
    base = base,
    treatment_name = "arm",
    outcome_names = c("Y_1", "Y_2"),
    propensity_model = "glm"
  )

  res_eif <- res_eif$win_proportion$value

  res_eif
}
stopCluster(cl)
```


### Approximation of the true causal measure

In what follows, we construct an approximation of the causal measure $\tau^{\star}$ defined in @even2025 and which is revisited in Example 1 for completeness.

```{r, message=FALSE, warning=FALSE, results='hide', cache=TRUE, eval = FALSE}
library(MASS)
mu <- c(0, 0) # Covariates mean
sigma <- matrix(c(1, 0.6, 0.6, 1), 2, 2)
tau_cont <- 2 # ATE of continuous outcome
tau_bin <- 0.8 # ATE on logit scale of binary outcome

# Default win function
win_function <- function(y, z) {
  if (all(y == z)) {
    return(0) # Tie
  }
  result <- (y > z)[which.max(y != z)] * 1
  return(result)
}

mean_given <- function(x) {
  n_samples <- 10000
  # Binary potential outcomes
  lin_pred0 <- -1 + 0.3 * x[1] - 0.5 * x[2]
  lin_pred1 <- lin_pred0 + tau_bin
  prob0 <- 1 / (1 + exp(-lin_pred0))
  prob1 <- 1 / (1 + exp(-lin_pred1))
  Y0_bin <- rbinom(n_samples, size = 1, prob = prob0)
  Y1_bin <- rbinom(n_samples, size = 1, prob = prob1)

  # Continuous Potential Outcomes
  Y0_cont <- 1 + 0.5 * x[1] - 0.7 * x[2] + rnorm(n_samples, 0, 1)
  Y1_cont <- 1 + 0.5 * x[1] - 0.7 * x[2] + rnorm(n_samples, 0, 1) + tau_cont

  wins_given_x <- mapply(function(yb, yc, zb, zc) {
    win_function(c(yb, yc), c(zb, zc))
  }, Y1_bin, Y1_cont, Y0_bin, Y0_cont)

  return(mean(wins_given_x))
}

set.seed(123)

covariates <- as.data.frame(mvrnorm(10000, mu = mu, Sigma = sigma))

tau_star <- mean(apply(covariates, 1, function(row) mean_given(row)))

```

### Plot

The plot displays the simulation boxplots alongside the target causal measure.

```{r myplot3, fig.width=6, fig.height=4, dev='png', dpi=96, eval = FALSE}
boxplot(results_eif,
  main = "Win proportion with EIF",
  xlab = "Number of patients 10000",
  ylab = "Win proportion"
)
abline(h = tau_star, lty = 2, col = "red")
```

```{r, echo=FALSE, out.width="70%"}
knitr::include_graphics("figures/EIF_resPlot.png")
```

## Computation of the Confidence Interval for Win Ratio
Let $w$ and $l$ denote the win and loss vectors, respectively, as computed by any of the three methods. The win ratio is defined as $\bar{w} / \bar{l}$, where
\[
\bar{w} = \frac{1}{n} \sum_{i=1}^{n} w_i
\quad \text{and} \quad
\bar{l} = \frac{1}{n} \sum_{i=1}^{n} l_i,
\]
with $n$ denoting the number of individuals. Let $s_w^2$, $s_l^2$, and $s^2_{wl}$ denote the sample variances of $w$, $l$ and the sample covariance of $(w,l)$, i.e.,
\begin{equation}
\begin{aligned}
s^2_w &= \frac{1}{n-1}\sum_i (w_i-\bar w)^2, \quad 
s^2_l = \frac{1}{n-1}\sum_i (l_i-\bar l)^2\quad \text{ and} \\
s^2_{wl} &= \frac{1}{n-1}\sum_i (w_i-\bar w)(l_i-\bar l)
\end{aligned}
\end{equation}
To obtain the confidence interval for the win ratio we first compute 
\begin{equation}
s_\text{log} = \sqrt{\frac{s^2_w}{n\bar w^2}+\frac{s^2_l}{n\bar l^2}-2\frac{s^2_{wl}}{n \bar w \bar l}}
\end{equation}
which can be seen to be an approximation of the variance of $\log(\bar w/ \bar l)=\log(\bar w) -\log(\bar l)$ using the delta method. The confidence interval is then computed by
\begin{equation}
\Big[\exp\big(\log(\bar w/ \bar l)-1.96 s_{\text{log}})\big), \exp\big(\log(\bar w \bar l)+1.96 s_{\text{log}})\big)\Big];
\end{equation}
which can be seen as the exponential of the confidence interval for the $\log(\bar w/\bar l)$.

## References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/eif_win_ratio.R
\name{eif_win_ratio}
\alias{eif_win_ratio}
\title{Win/Loss Ratios with Efficient Influence Functions}
\usage{
eif_win_ratio(
  base,
  treatment_name,
  outcome_names,
  win_function = "lexicographic",
  distance = NULL,
  n_trees_drf = 1000,
  n_of_folds = 3,
  seed = NULL,
  propensity_model = "probability_forest",
  n_trees_propensity = 1000,
  propensity_scores = NULL,
  clip_propensity = 0
)
}
\arguments{
\item{base}{A data frame with n rows (individuals) and p columns.
It must include a treatment column and one or more outcome columns.
All remaining columns are considered covariates for matching.
The data frame should not contain missing values. All covariates must be either numeric or factors.}

\item{treatment_name}{A character vector of length one for the treatment column name, must be in \code{names(base)}.
The treatment column should contain only zeros and ones, with ones indicating the treatment group.}

\item{outcome_names}{A character vector specifying the names of outcome columns.
All names must exist in \code{names(base)}. Each outcome column should be numeric or binary and
binary outcomes must be encoded as 0 and 1.}

\item{win_function}{By default, this function compares outcomes lexicographically according to the column order in the data frame,
treating higher values as better. Once a distinct outcome is found, the function yields 1 (a win) if that outcome is larger
for the treated individual and 0 otherwise; in case of a tie, it yields 0.
To change the priority of outcomes, simply reorder the columns of the data frame.
Alternatively, \code{win_function} can be a custom function that takes two arguments, each corresponding to a row of the data frame:
\code{win_function(base[i, ], base[j, ])}
where the first argument represents a treated individual and the second a control individual.
The function must return a value between 0 and 1, with 1 indicating a win for the treated individual.}

\item{distance}{A function that is used to compute the nearest neighbor matching on covariates.
The distance function will be passed as an argument to \code{\link[MatchIt]{matchit}} (see  \code{\link[MatchIt]{distance}}).

\strong{Default Distance Settings}

The default value for the distance parameter is \code{NULL}. If no distance is provided, the function assigns defaults based on the type of covariates:
\itemize{
\item \strong{Mixed covariates:} Applies Factor Analysis of Mixed Data transformation (see \code{\link[FactoMineR]{FAMD}}) to the covariates and sets distance to \code{"euclidean"}.
\item \strong{Numeric covariates:} Sets distance to \code{"euclidean"}.
\item \strong{Categorical covariates:} Applies Multiple Correspondence Analysis (see \code{\link[FactoMineR]{MCA}}) transformation to the covariates and sets distance to \code{"euclidean"}.
}}

\item{n_trees_drf}{Number of trees grown in the distributional random forests.
It passed as the argument \code{num.trees} to \code{\link[drf]{drf}}. The default value is 1000.}

\item{n_of_folds}{Number of folds used in cross-fitting. The default value is 3.}

\item{seed}{Numeric value used in \code{set.seed()} to guarantee reproducible results when sampling the folds. The default value is \code{NULL}.}

\item{propensity_model}{Character string specifying the type of model to use.
Must be either "glm" or "probability_forest".
Defaults to "probability_forest". The model is only used if no vector
of propensity scores (\code{propensity_scores}) is provided.}

\item{n_trees_propensity}{Number of trees grown when computing the propensity scores using \code{propensity_model}.}

\item{propensity_scores}{Numeric vector of propensity score probabilities}

\item{clip_propensity}{Numeric value used to clip propensity scores,
ensuring they lie within the interval \verb{[clip_propensity, 1 - clip_propensity]}. The default value is zero.}
}
\value{
A list of six elements, each of which is a list structured as follows:

The first element, \code{win_proportion}, is a list with two components: \code{value} and \code{std},
where \code{std} represents the standard deviation.

The second element, \code{lose_proportion}, is a list with two components: \code{value} and \code{std},
where \code{std} represents the standard deviation.

The third element, \code{win_ratio}, is a list containing three components: \code{value}, \code{lower_CI},
and \code{upper_CI}, with \code{lower_CI} and \code{upper_CI} representing the confidence interval bounds.

The fourth element, \code{net_benefit}, is a list containing three components: \code{value}, \code{lower_CI},
and \code{upper_CI}, with \code{lower_CI} and \code{upper_CI} representing the confidence interval bounds.

The fifth and sixth elements, \code{win_vector} and \code{lose_vector}, are numeric vectors containing the plug-in estimator
evaluated for each individual, along with the corresponding EIF correction term.
}
\description{
\code{eif_win_ratio()} calculates the win/loss proportion, win ratio, and net benefit
by adding a correction term to \code{drf_win_ratio()} using Efficient Influence Functions.
}
\examples{
## Input Propensity Scores ##

set.seed(123)
n <- 100
base <- data.frame(
  X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
  X2 = rnorm(n, mean = 10, sd = 3), # numeric covariate 2
  X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
  Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
  arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
)
treatment_name <- "arm"
outcome_names <- c("Y1", "Y2")

ps_model <- stats::glm(arm ~ X1 + X3, # only consider X1 and X3 and no cross-fitting
  family = binomial(),
  data = base
)

propensity_scores <- stats::predict(ps_model, type = "response")
res <- eif_win_ratio(
  base = base,
  treatment_name = treatment_name,
  outcome_names = outcome_names,
  propensity_scores = propensity_scores
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/drf_win_ratio.R
\name{drf_win_ratio}
\alias{drf_win_ratio}
\title{Win/Loss Ratios with Distributional Random Forests}
\usage{
drf_win_ratio(
  base,
  treatment_name,
  outcome_names,
  win_function = "lexicographic",
  n_trees_drf = 1000,
  n_of_folds = 3,
  seed = NULL
)
}
\arguments{
\item{base}{A data frame with n rows (individuals) and p columns.
It must include a treatment column and one or more outcome columns.
All remaining columns are considered covariates for matching.
The data frame should not contain missing values. All covariates must be either numeric or factors.}

\item{treatment_name}{A character vector of length one for the treatment column name, must be in \code{names(base)}.
The treatment column should contain only zeros and ones, with ones indicating the treatment group.}

\item{outcome_names}{A character vector specifying the names of outcome columns.
All names must exist in \code{names(base)}. Each outcome column should be numeric or binary and
binary outcomes must be encoded as 0 and 1.}

\item{win_function}{By default, this function compares outcomes lexicographically according to the column order in the data frame,
treating higher values as better. Once a distinct outcome is found, the function yields 1 (a win) if that outcome is larger
for the treated individual and 0 otherwise; in case of a tie, it yields 0.
To change the priority of outcomes, simply reorder the columns of the data frame.
Alternatively, \code{win_function} can be a custom function that takes two arguments, each corresponding to a row of the data frame:
\code{win_function(base[i, ], base[j, ])}
where the first argument represents a treated individual and the second a control individual.
The function must return a value between 0 and 1, with 1 indicating a win for the treated individual.}

\item{n_trees_drf}{Number of trees grown in the forest.
It passed as the argument \code{num.trees} to \code{\link[drf]{drf}}. The default value is 1000.}

\item{n_of_folds}{Number of folds used in cross-fitting. The default value is 3.}

\item{seed}{Numeric value used in \code{set.seed()} to guarantee reproducible results when sampling the folds. The default value is \code{NULL}.}
}
\value{
A list of four elements, each of which is a list structured as follows:

The first element, \code{win_proportion}, is a list with two components: \code{value} and \code{std},
where \code{std} represents the standard deviation.

The second element, \code{lose_proportion}, is a list with two components: \code{value} and \code{std},
where \code{std} represents the standard deviation.

The third element, \code{win_ratio}, is a list containing three components: \code{value}, \code{lower_CI},
and \code{upper_CI}, with \code{lower_CI} and \code{upper_CI} representing the confidence interval bounds.

The fourth element, \code{net_benefit}, is a list containing three components: \code{value}, \code{lower_CI},
and \code{upper_CI}, with \code{lower_CI} and \code{upper_CI} representing the confidence interval bounds.

The fifth and sixth elements, win_vector and lose_vector, are numeric vectors containing the nuisance function values evaluated for each individual.
}
\description{
\code{drf_win_ratio()} Computes the win/loss proportion, win ratio, and net benefit
by estimating nuisance parameters with machine learning methods.
This estimation is performed via distributional regression, implemented using distributional random forests.
}
\examples{
## Mixed Covariates ##

set.seed(123)
n <- 100
base <- data.frame(
  X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
  X2 = rnorm(n, mean = 10, sd = 3), # numeric covariate 2
  X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
  Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
  arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
)
treatment_name <- "arm"
outcome_names <- c("Y1", "Y2")
res <- drf_win_ratio(
  base = base,
  treatment_name = treatment_name,
  outcome_names = outcome_names
)
## Categorical Covariates ##

set.seed(123)
n <- 100
base <- data.frame(
  X1 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  X2 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
  Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
  arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
)
treatment_name <- "arm"
outcome_names <- c("Y1", "Y2")
res <- drf_win_ratio(
  base = base,
  treatment_name = treatment_name,
  outcome_names = outcome_names
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nn_win_ratio.R
\name{nn_win_ratio}
\alias{nn_win_ratio}
\title{Win/Loss Ratios with Nearest Neighbor Matching}
\usage{
nn_win_ratio(
  base,
  treatment_name,
  outcome_names,
  win_function = "lexicographic",
  distance = NULL
)
}
\arguments{
\item{base}{A data frame with n rows (individuals) and p columns.
It must include a treatment column and one or more outcome columns.
All remaining columns are considered covariates for matching.
The data frame should not contain missing values. All covariates must be either numeric or factors.}

\item{treatment_name}{A character vector of length one for the treatment column name, must be in \code{names(base)}.
The treatment column should contain only zeros and ones, with ones indicating the treatment group.}

\item{outcome_names}{A character vector specifying the names of outcome columns.
All names must exist in \code{names(base)}. Each outcome column should be numeric or binary and
binary outcomes must be encoded as 0 and 1.}

\item{win_function}{By default, this function compares outcomes lexicographically according to the column order in the data frame,
treating higher values as better. Once a distinct outcome is found, the function yields 1 (a win) if that outcome is larger
for the treated individual and 0 otherwise; in case of a tie, it yields 0.
To change the priority of outcomes, simply reorder the columns of the data frame.
Alternatively, \code{win_function} can be a custom function that takes two arguments, each corresponding to a row of the data frame:
\code{win_function(base[i, ], base[j, ])}
where the first argument represents a treated individual and the second a control individual.
The function must return a value between 0 and 1, with 1 indicating a win for the treated individual.}

\item{distance}{A function that is used to compute the nearest neighbor matching on covariates.
The distance function will be passed as an argument to \code{\link[MatchIt]{matchit}} (see  \code{\link[MatchIt]{distance}}).

\strong{Default Distance Settings}

The default value for the distance parameter is \code{NULL}. If no distance is provided, the function assigns defaults based on the type of covariates:
\itemize{
\item \strong{Numeric covariates:} Sets distance to \code{"euclidean"}.
\item \strong{Categorical covariates:} Applies Multiple Correspondence Analysis (see \code{\link[FactoMineR]{MCA}}) transformation to the covariates and sets distance to \code{"euclidean"}.
\item \strong{Mixed covariates:} Applies Factor Analysis of Mixed Data transformation (see \code{\link[FactoMineR]{FAMD}}) to the covariates and sets distance to \code{"euclidean"}.
}}
}
\value{
A list of six elements, each of which is a list structured as follows:

The first element, \code{win_proportion}, is a list with two components: \code{value} and \code{std},
where \code{std} represents the standard deviation.

The second element, \code{lose_proportion}, is a list with two components: \code{value} and \code{std},
where \code{std} represents the standard deviation.

The third element, \code{win_ratio}, is a list containing three components: \code{value}, \code{lower_CI},
and \code{upper_CI}, with \code{lower_CI} and \code{upper_CI} representing the confidence interval bounds.

The fourth element, \code{net_benefit}, is a list containing three components: \code{value}, \code{lower_CI},
and \code{upper_CI}, with \code{lower_CI} and \code{upper_CI} representing the confidence interval bounds.

The fifth and sixth elements, \code{win_vector} and \code{lose_vector}, are numeric vectors representing the number of wins and losses
for each matched element, respectively. Their entries follow the same order as the rows in \code{base}.
}
\description{
\code{nn_win_ratio()} calculates the win/loss proportion, win ratio, and net benefit
by performing nearest-neighbor matching between individuals in the treatment group
and those in the control group based on a specified ground distance. After matching,
the outcomes of paired individuals are compared to determine winners and losers.
}
\examples{
## Mixed Covariates ##

set.seed(123)
n <- 100
base <- data.frame(
  X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
  X2 = rnorm(n, mean = 10, sd = 3), # numeric covariate 2
  X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
  Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
  arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
)
treatment_name <- "arm"
outcome_names <- c("Y1", "Y2")
res <- nn_win_ratio(
  base = base,
  treatment_name = treatment_name,
  outcome_names = outcome_names
)

## Categorical Covariates ##

set.seed(123)
n <- 100
base <- data.frame(
  X1 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  X2 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  X3 = factor(sample(c("A", "B", "C"), n, replace = TRUE)), # factor covariate
  Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
  Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
  arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
)
treatment_name <- "arm"
outcome_names <- c("Y1", "Y2")
res <- nn_win_ratio(
  base = base,
  treatment_name = treatment_name,
  outcome_names = outcome_names
)

## Input a Distance Matrix ##

set.seed(123)
n <- 100
base <- data.frame(
  X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
  X2 = rnorm(n, mean = 5, sd = 2), # numeric covariate 2
  X3 = rnorm(n, mean = 5, sd = 2), # numeric covariate 3
  Y1 = rnorm(n, mean = 50, sd = 10), # numeric outcome 1
  Y2 = rnorm(n, mean = 100, sd = 20), # numeric outcome 2
  arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
)
treatment_name <- "arm"
outcome_names <- c("Y1", "Y2")

covariate_names <- setdiff(colnames(base), c(outcome_names, treatment_name))
covariate_data <- base[, covariate_names, drop = FALSE]
distance_matrix <- as.matrix(dist(covariate_data, method = "euclidean"))

res_dist <- nn_win_ratio(
  base = base,
  treatment_name = treatment_name,
  outcome_names = outcome_names,
  distance = distance_matrix
)

res <- nn_win_ratio(
  base = base,
  treatment_name = treatment_name,
  outcome_names = outcome_names
)

res <- unlist(res)
res_dist <- unlist(res_dist)

print(all.equal(res, res_dist))

## Input a Win function ##

set.seed(123)
n <- 100
base <- data.frame(
  X1 = rnorm(n, mean = 5, sd = 2), # numeric covariate 1
  X2 = rnorm(n, mean = 5, sd = 2), # numeric covariate 2
  X3 = rnorm(n, mean = 5, sd = 2), # numeric covariate 3
  Y1 = rbinom(n, size = 1, prob = 0.5), # binary outcome 1 (0/1) with 50\% chance
  Y2 = rbinom(n, size = 10, prob = 0.7), # counts out of 10 trials with 70\% success rate
  arm = sample(c(0, 1), n, replace = TRUE) # binary treatment arm
)
treatment_name <- "arm"
outcome_names <- c("Y1", "Y2")

# Contrary to the default win function, which yields 0 for ties,
# the following win function yields 0.5.

win_function <- function(treated_row, control_row) {
  y <- as.matrix(treated_row[, outcome_names], drop = FALSE)
  z <- as.matrix(control_row[, outcome_names], drop = FALSE)
  if (all(y == z)) {
    return(0.5) # Tie, a zero in the default win function
  }
  result <- (y > z)[which.max(y != z)] * 1
  return(result)
}

res <- nn_win_ratio(
  base = base,
  treatment_name = treatment_name,
  outcome_names = outcome_names,
  win_function = win_function
)
}
